<template>
<div class="echarts">
    <div class="hello">
        <query-renderer :cubejs-api="cubejsApi" :query="query">
        <template v-slot="{ measures, resultSet, loading }">
            <line-chart :data="transformData(resultSet)"></line-chart>
        </template>
        </query-renderer>
    </div>
    <!--<1<q-card >
        <h5>BarChart of Items</h5>
        <div class="q-pa-md">
            <div class="q-gutter-md row" direction="right">
                <q-select filled v-model="product" use-input hide-selected fill-input input-debounce="0" :options="options" style="width: 250px; padding-bottom: 32px" label="Select Product">
                </q-select>
            </div>
        </div>
        <q-card-section class="q-pa-none map_height">
            <IEcharts :option="getBarChartOptions" :resizable="true" />
        </q-card-section>
    </q-card>-->
</div>
</template>

<script>
import IEcharts from 'vue-echarts-v3/src/full.js';
import cubejs from '@cubejs-client/vue';
import { QueryRenderer } from '@cubejs-client/vue';
import Vue from 'vue'
import VueChartKick from 'vue-chartkick';
import Chart from 'chart.js';

Vue.use(VueChartKick, {adapter:Chart});

const cubejsApi = cubejs('d30d38a4b00820ce111880607a63fcc94fd581d8ade7b40aabc8ede7924ddddd57f2bbba9269610fef242d5c594b3a9b409742d1b881c6b7508f86264145b3a8', {
    apiUrl: 'http://localhost:4000/cubejs-api/v1',
});

export default {
    name: 'BarChart',
    components: {
        IEcharts,
        QueryRenderer
    },
    props: {
        ['product', 'data', 'options'],
        msg: string
        },
    
    data() {
        const query = {
            measures: ['LineItems.sum'],
            timeDimensions: [
                {
                    dimension: 'LineItems.productline',
                    granularity: 'month',
                },
            ],
        };
        return {
            cubejsApi,
            query,
        };
    },
    
    methods: {
        transformData(resultSet){
            const seriesNames = resultSet.seriesNames();
            const pivot = resultSet.chartPivot();
            const series = [];
            seriesNames.froEach((e) => {
                const data = pivot.map((p) => [p.x, p[e.key]]);
                series.push({ name: e.key, data });
            });
            return series;  
        },
    },
    computed: {
        getBarChartOptions() {
            let self = this;
            let filtered_data = this.data.filter(function (item) {
                return item['product'] == self.product
            })
            return {
                
                legend: {
                    show: true
                },
                xAxis: {
                    type: 'category',
                    axisLabel: {},
                    nameLoction: "middle",
                    nameGap: 78,
                },
                tooltip: {
                    show: true,
                    trigger: 'axis',
                    axisPointer: {
                        type: 'cross',
                        label: {
                            backgroundColor: '#6a7985'
                        },
                        crossStyle: {
                            color: '#999',
                        }
                        // animation: true
                    },
                    formatter: function(params,type) {
                        console.log("params", params)
                        let resultVal = ''
                        for(let i=0;i<params.length;i++){
                            let item = params[i];
                            // console.log("ft",item.value[componentIndex]);
                            resultVal = `${item.name} in ${item.seriesName}<br>`
                        }

                        return resultVal
                    }
                },
                dataset: {
                    dimensions: ['product', '2019', '2020', '2021'],
                    source: filtered_data
                },
                yAxis: {
                    type: 'value',
                    splitLine: {
                        show: false
                    }
                },
                series: [{
                        type: 'bar',
                        itemStyle: {
                            barBorderRadius: [15, 15, 0, 0]
                        }
                    },
                    {
                        type: 'bar',
                        itemStyle: {
                            barBorderRadius: [15, 15, 0, 0]
                        }
                    },
                    {
                        type: 'bar',
                        itemStyle: {
                            barBorderRadius: [15, 15, 0, 0]
                        }
                    }
                ]
            }
        }
    }
}
</script>

<style scoped>
.echarts {
    width: 400px;
    height: 400px;
}

.map_height {
    height: 398px;
}
</style>
